using System;

using Shop;
using ShopCommon;

namespace TestConsole
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			TesteLogin();

			//
			// customer
			//
			TesteCustomerGetById();
			TesteCustomerUpdateData();
			TesteCustomerAdd();

			//
			// products
			//
			//TODO: testar componente 'Products'

			//
			// sale
			//
			//TODO: testar componente 'Sale'
			TesteSaleAdd();


			System.Console.ReadLine();
		}

		static void TesteLogin()
		{
			//
			// criar componente
			//
			Shop.User userComp = new User();

			//
			// invocar mtodo do componente
			//
			if (userComp.Validate("Joao", "Joao") == ShopCommon.Status.OK)
				System.Console.WriteLine("Utilizador vlido");
			else
				System.Console.WriteLine("Utilizador **invlido** ou erro!!!");
		}

		static void TesteCustomerGetById()
		{
			//
			// criar componente
			//
			Shop.Customer custComp = new Customer();

			//
			// invocar mtodo do componente
			//
			int idCust = 37;
			ShopCommon.CustomerDataset dsCust = custComp.GetByID("Joao", "Joao", idCust);
			if (dsCust != null)
			{
				if (dsCust.Customers.Count == 0)
					System.Console.WriteLine("Esse cliente NO existe");
				else
					System.Console.WriteLine("Cliente {0} : {1}", idCust, dsCust.Customers[0]["name"]);
			}
		}

		static void TesteCustomerUpdateData()
		{
			//
			// criar componente
			//
			Shop.Customer custComp = new Customer();

			//
			// invocar mtodo do componente
			//
			int idCust = 37;
			if (custComp.UpdateCustomerData("Joao", "Joao", idCust, "!!nome!!", "!!morada!!", "!!tel.!!", "!!fax!!", "!!email!!") != ShopCommon.Status.OK)
				System.Console.WriteLine("Esse cliente NO existe");
			else
				System.Console.WriteLine("Cliente actualizado");
		}

		static void TesteCustomerAdd()
		{
			//
			// criar componente
			//
			Shop.Customer custComp = new Customer();

			//
			// invocar mtodo do componente
			//
			ShopCommon.Status status;
			long idCust = custComp.AddCustomer("Joao", "Joao", "!!nome!!", "!!morada!!", "!!tel.!!", "!!fax!!", "!!email!!", out status);
			//long idCust = custComp.AddCustomer2("Joao", "Joao", "!!nome!!", "!!morada!!", "!!tel.!!", "!!fax!!", "!!email!!", out status);
			if (status != ShopCommon.Status.OK)
				System.Console.WriteLine("Esse cliente NO foi inserido");
			else
				System.Console.WriteLine("Cliente inserido com cdigo {0}", idCust);
		}

		static void TesteSaleAdd()
		{
			//
			// criar componente
			//
			Shop.Sale saleComp = new Sale();

			//
			// invocar mtodo do componente
			//
			ShopCommon.SalesDetailDataSet dsDetails = saleComp.CreateSalesDetail("Joao", "Joao");

			//
			// inserir linhas de venda no registo
			//
			dsDetails.SaleDetails.AddSaleDetailsRow(0, 10, 1, 0);
			ShopCommon.SalesDetailDataSet.SaleDetailsRow row = (ShopCommon.SalesDetailDataSet.SaleDetailsRow)dsDetails.SaleDetails.NewRow();
			row["ProductID"] = 12;
			row["Quantity"] = 1;
			dsDetails.SaleDetails.Rows.Add(row);

			//
			// invocar mtodo do componente
			//
			ShopCommon.Status status = saleComp.AddSale("Joao", "Joao", 33, new DateTime(2003, 12, 1), dsDetails);
			if (status != ShopCommon.Status.OK)
				System.Console.WriteLine("Essa venda NO foi inserida");
			else
				System.Console.WriteLine("Vanda inserida com sucesso");
		}
	}
}
